foreach name [array names env STOOOP*] {unset env($name)}                                ;# reset any existing environment variables
set env(STOOOPCHECKOBJECTS) {}
source stooop.tcl
namespace import stooop::*

### objects checking with debugging procedures invocation from namespace body and namespace procedure

# expected output:
### with output:
## stooop::record invoked from ::n::p
## stooop::report invoked from ::n::p:
## + ::a(1) created in ::n::p
## stooop::record invoked from ::n::m::q
## stooop::report invoked from ::n::m::q:
## + ::a(2) created in ::n::m::q
## stooop::record invoked from namespace ::n
## stooop::report invoked from namespace ::n:
## + ::a(3) created in namespace ::n

class a {
    proc a {this} {}
    proc ~a {this} {}
}
namespace eval n {
    proc p {} {
        stooop::record
        new a
        stooop::report
    }
    namespace eval m {
        proc q {} {
            stooop::record
            new a
            stooop::report
        }
    }
}
n::p
n::m::q
namespace eval n {
    stooop::record
    new a
    stooop::report
}
